<script setup lang="ts">
import type { User, Report } from '@/scripts/api-helper'
import { useAppStore } from '@/stores/app'

import Preview from '@/components/Preview.vue'
import AppCard from '@/components/ui/AppCard.vue'
import { RouterLink } from 'vue-router'
import AppButton from './ui/AppButton.vue'

const emits = defineEmits<{
  reject: []
}>()

const app = useAppStore()

const props = defineProps<{
  user: User
  reports: Report[]
}>()
</script>

<template>
  <AppCard dense :containerClass="props.user.rejected ? 'bg-red dark:bg-red-800' : ''">
    <div class="mb-3 flex justify-between">
      <div class="flex flex-col space-y-1">
        <span
          v-if="props.user.profile_picture_status === 'Ready'"
          class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
        >
          PP ready
        </span>
        <span
          v-else
          class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
        >
          {{ props.user.profile_picture_status }}
        </span>

        <span
          v-if="props.user.form_validated"
          class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
        >
          Form validated
        </span>
        <span
          v-else
          class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
        >
          Form not validated
        </span>
      </div>
      <AppButton @click="emits('reject')">{{
        props.user.rejected ? 'Undo reject' : 'Reject'
      }}</AppButton>
    </div>
    <div>
      <RouterLink :to="`/admin/user/${user.sciper}`">
        <Preview
          :firstname="props.user.preferred_firstname ?? '<EMPTY>'"
          :lastname="props.user.preferred_lastname ?? '<EMPTY>'"
          :profile-picture-url="
            user.profile_picture_status === 'Ready'
              ? `/api/admin/profile-picture-thumbnail/${props.user.sciper}?key=${app.adminKey}`
              : undefined
          "
          static-background="bg-gray-300"
        />
      </RouterLink>
    </div>
    <div class="mt-3 flex justify-between">
      <p class="text-gray-900 dark:text-white">{{ props.user.sciper }}</p>
      <p class="text-gray-900 dark:text-white">Reports: {{ props.reports.length }}</p>
    </div>
  </AppCard>
</template>
